/*
 * tcpWinTMT.h
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */

#ifndef __TCP_WINTMT_H__
#define __TCP_WINTMT_H__

// global includes

// local includes

#include "t2Plugin.h"


/* ========================================================================== */
/* ------------------------ USER CONFIGURATION FLAGS ------------------------ */
/* ========================================================================== */

#define TCPWIN_THRES  1	// tcpwin theshold undershoot flag 
#define TCPWIN_FLWPRG 2 // Threshold to abort a flow

/* ========================================================================== */
/* ------------------------- DO NOT EDIT BELOW HERE ------------------------- */
/* ========================================================================== */

// Status variable: stat
#define TCPWIN_THU   0x80  // TCPWIN threshold undershoot
#define TCPWIN_ABNRM 0x40

// states
#define NEW  0x00
#define BGN  0x01
#define EST  0x02
#define ABRT 0x04

// timeouts @ states
#define TMT_NEW  10.0f  // 10 s
#define TMT_BGN  2.2f   // 2.2 s
#define TMT_EST  1.0f   // 1.0 s
#define TMT_ABRT 0.001f // 1 ms

// plugin structures
typedef struct { 		// always large variables first to limit memory fragmentation
        uint32_t winThCnt;	// win undershoot count
        uint8_t state;		// plugin flow state
        uint8_t stat;		// plugin flow status
} tcpWinFlow_t;

// plugin struct pointer for potential dependencies
extern tcpWinFlow_t *tcpWinFlows;

#endif // __TCP_WINTMT_H__
